#include "jboci.h"

int ProcessSequence(HWND hWnd,char *schema,char *sequence)
{
  char *tablestr="select MIN_VALUE,MAX_VALUE,INCREMENT_BY,CYCLE_FLAG,ORDER_FLAG,CACHE_SIZE,LAST_NUMBER from all_sequences where sequence_owner=:p_schema and sequence_name=:p_sequence";
  char min_value[39],max_value[39]="",increment_by[39]="",cycle_flag[2]="",order_flag[2]="",cache_size[39]="",last_number[39]="";
  ub2 min_value_i=-1,max_value_i=-1,increment_by_i=-1,cycle_flag_i=-1,order_flag_i=-1,cache_size_i=-1,last_number_i=-1;
  OCIBind *bndhp=NULL;
  OCIDefine *defhp=NULL;
  OCIStmt *stmtp=NULL;

  if (ChkOCIErrS(OCIHandleAlloc(g_oci->envhp, 
                               (dvoid**)&stmtp,
                               OCI_HTYPE_STMT, 
                               0, 
                               NULL)))
  {
    return -1;
  }
  if (ChkOCIErrS(OCIStmtPrepare(stmtp,
                               g_oci->errhp,
                               tablestr,
                               strlen(tablestr),
                               OCI_NTV_SYNTAX,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_schema",
                             strlen("p_schema"),
                             schema,
                             strlen(schema)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIBindByName(stmtp,
                             &bndhp,
                             g_oci->errhp,
                             "p_sequence",
                             strlen("p_sequence"),
                             sequence,
                             strlen(sequence)+1,
                             SQLT_STR,
                             NULL,
                             NULL,
                             NULL,
                             0,
                             NULL,
                             OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               1,
                               min_value,
                               sizeof(min_value),
                               SQLT_STR,
                               &min_value_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               2,
                               max_value,
                               sizeof(max_value),
                               SQLT_STR,
                               &max_value_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               3,
                               increment_by,
                               sizeof(increment_by),
                               SQLT_STR,
                               &increment_by_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               4,
                               cycle_flag,
                               sizeof(cycle_flag),
                               SQLT_STR,
                               &cycle_flag_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               5,
                               order_flag,
                               sizeof(order_flag),
                               SQLT_STR,
                               &order_flag_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               6,
                               cache_size,
                               sizeof(cache_size),
                               SQLT_STR,
                               &cache_size_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }

  if (ChkOCIErrS(OCIDefineByPos(stmtp,
                               &defhp,
                               g_oci->errhp,
                               7,
                               last_number,
                               sizeof(last_number),
                               SQLT_STR,
                               &last_number_i,
                               NULL,
                               NULL,
                               OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }


  if (ChkOCIErrS(OCIStmtExecute(g_oci->svchp,
                        stmtp,
                        g_oci->errhp,
                        0,
                        0,
                        NULL,
                        NULL,
                        OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  if (ChkOCIErrS(OCIStmtFetch(stmtp,
                      g_oci->errhp,
                      1,
                      OCI_FETCH_NEXT,
                      OCI_DEFAULT)))
  {
    OCIHandleFree(stmtp,OCI_HTYPE_STMT);
    stmtp=NULL;
    return -1;
  }
  OCIHandleFree(stmtp,OCI_HTYPE_STMT);
  stmtp=NULL;
  SchemaPrintf(hWnd,"CREATE SEQUENCE \"%s\"\n",sequence);
  if (min_value_i!=(ub2)-1)
    SchemaPrintf(hWnd,"MINVALUE %s\n",min_value);
  if (max_value_i!=(ub2)-1)
    SchemaPrintf(hWnd,"MAXVALUE %s\n",max_value);
  if (increment_by_i!=(ub2)-1)
    SchemaPrintf(hWnd,"INCREMENT BY %s\n",increment_by);
  if (cycle_flag_i!=(ub2)-1)
  {
    if (!strcmp(cycle_flag,"N"))
      SchemaPrintf(hWnd,"NOCYCLE\n");
    else
      SchemaPrintf(hWnd,"CYCLE\n");
  }
  if (order_flag_i!=(ub2)-1)
  {
    if (!strcmp(order_flag,"N"))
      SchemaPrintf(hWnd,"NOORDER\n");
    else
      SchemaPrintf(hWnd,"ORDER\n");
  }
  if (cache_size_i!=(ub2)-1)
    SchemaPrintf(hWnd,"CACHE %s\n",cache_size);
  else
    SchemaPrintf(hWnd,"NOCACHE\n");
  if (last_number_i!=(ub2)-1)
    SchemaPrintf(hWnd,"START WITH %s\n",last_number);
  SchemaPrintf(hWnd,"/\n\n");
  return 0;
}

